// vtkSq3SubdivisionView.cpp : Implementierung der Klasse CvtkSq3SubdivisionView
//

#include "stdafx.h"
#include "vtkSq3Subdivision.h"
#include "vtkSq3SubdivisionDoc.h"
#include "vtkSq3SubdivisionView.h"
#include "VTK3DSOurImporter.h"
#include "vtkConeSource.h"
#include "vtkPolyDataMapper.h"
#include "vtkRenderWindow.h"
#include "vtkLoopSubdivisionFilter.h"
#include "vtkTriangleFilter.h"
#include "vtkActorCollection.h"
#include "vtkPolyData.h"
#include "vtkRenderWindowInteractor.h"
#include "vtkRenderer.h"
#include "vtkCellArray.h"
#include "vtkCommand.h"
#include "MainFrm.h"
#include "vtkLoopSubdivisionFilter.h"
#include "vtkLinearSubdivisionFilter.h"
#include "vtkButterflySubdivisionFilter.h"
#include "vtkSQ3SubdivisionFilter.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

bool first = TRUE;


// CvtkSq3SubdivisionView

IMPLEMENT_DYNCREATE(CvtkSq3SubdivisionView, CView)

BEGIN_MESSAGE_MAP(CvtkSq3SubdivisionView, CView)
	// Standarddruckbefehle
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_ERASEBKGND()
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_BUTTON1, OnClick)
	ON_BN_CLICKED(IDC_BUTTON2, OnClick)
	ON_BN_CLICKED(IDC_BUTTON3, OnClick)
	ON_BN_CLICKED(IDC_BUTTON4, OnClick)
END_MESSAGE_MAP()

// CvtkSq3SubdivisionView Erstellung/Zerstrung

CvtkSq3SubdivisionView::CvtkSq3SubdivisionView()
{
first = TRUE;
}

CvtkSq3SubdivisionView::~CvtkSq3SubdivisionView()
{
	// Delete the the renderer, window and interactor objects.
	if (!first)
	{this->ren->Delete();
	this->iren->Delete();
	this->renWin->Delete();
	this->loopFilter->Delete();
	this->linearFilter->Delete();
	this->butterflyFilter->Delete();
	this->sq3Filter->Delete();
	this->ac->Delete();
	}

}

BOOL CvtkSq3SubdivisionView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ndern Sie hier die Fensterklasse oder die Darstellung, indem Sie
	//  CREATESTRUCT cs modifizieren.

	return CView::PreCreateWindow(cs);
}

// CvtkSq3SubdivisionView-Zeichnung

void CvtkSq3SubdivisionView::OnDraw(CDC* pDC)
{
	CvtkSq3SubdivisionDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	if (first)
	{
	// Create the the renderer, window and interactor objects.
	this->ren = vtkRenderer::New();
	this->renWin = vtkWin32OpenGLRenderWindow::New();
	this->iren = vtkWin32RenderWindowInteractor::New();

	//AfxMessageBox((char*)GetDocument()->fname);
	{
	importer = VTK3DSOurImporter::New();
	importer->SetPolys("triangle");
	importer->ComputeNormalsOn();
	importer->SetFileName(pDoc->fname);
	importer->Read();

	ac = importer->GetRenderer()->GetActors();
	//ac = ren->GetActors();
	ac->InitTraversal();
	vtkActor *dsActor=ac->GetNextActor();
	
	loopFilter = vtkLoopSubdivisionFilter::New();
	linearFilter = vtkLinearSubdivisionFilter::New();
	butterflyFilter = vtkButterflySubdivisionFilter::New();
	sq3Filter = vtkSQ3SubdivisionFilter::New();

	while (dsActor!=NULL) {
    vtkPolyData *polyData = (vtkPolyData*)(dsActor->GetMapper()->GetInputAsDataSet());

	loopFilter->SetInput(polyData);          
	loopFilter->SetNumberOfSubdivisions(0);  // set initial amount
	linearFilter->SetInput(polyData);          
	linearFilter->SetNumberOfSubdivisions(0);  // set initial amount
	butterflyFilter->SetInput(polyData);          
	butterflyFilter->SetNumberOfSubdivisions(0);  // set initial amount
	sq3Filter->SetInput(polyData);          
	sq3Filter->SetNumberOfSubdivisions(0);  // set initial amount

    vtkPolyDataMapper *mapper = vtkPolyDataMapper::New();
    mapper->SetInput(butterflyFilter->GetOutput());
    vtkActor *actor = vtkActor::New();

    actor->SetMapper(mapper);
    actor->SetProperty(dsActor->GetProperty()); 
    ren->AddActor(actor);
    dsActor=ac->GetNextActor();
	}
	}

	this->renWin->AddRenderer(this->ren);
	// setup the parent window
	this->renWin->SetParentId(this->m_hWnd);
	this->iren->SetRenderWindow(this->renWin);

	first = FALSE;


	}

	if ( !this->iren->GetInitialized() )
	{
		CRect rect;

		this->GetClientRect(&rect);
		this->iren->Initialize();
		this->renWin->SetSize(rect.right-rect.left,rect.bottom-rect.top);
		this->renWin->SetPosition(0,0);

		this->ren->ResetCamera();
	}

	// Invoke the pipeline
	Pipeline();

	this->renWin->Render();

}


// CvtkSq3SubdivisionView drucken

BOOL CvtkSq3SubdivisionView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// Standardvorbereitung
	return DoPreparePrinting(pInfo);
}

void CvtkSq3SubdivisionView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: Zustzliche Initialisierung vor dem Drucken hier einfgen
}

void CvtkSq3SubdivisionView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: Bereinigung nach dem Drucken einfgen
}


// CvtkSq3SubdivisionView Diagnose

#ifdef _DEBUG
void CvtkSq3SubdivisionView::AssertValid() const
{
	CView::AssertValid();
}

void CvtkSq3SubdivisionView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CvtkSq3SubdivisionDoc* CvtkSq3SubdivisionView::GetDocument() const // Nicht-Debugversion ist inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CvtkSq3SubdivisionDoc)));
	return (CvtkSq3SubdivisionDoc*)m_pDocument;
}
#endif //_DEBUG


int CvtkSq3SubdivisionView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	m_trackbar.Create(WS_CHILD|WS_VISIBLE|TBS_AUTOTICKS|TBS_BOTTOM|TBS_HORZ, CRect(0,0,150,33), this, IDC_TRACKBAR);
	m_trackbar.SetRange(0,5,TRUE);
	m_trackbar.SetTicFreq(1);
	m_trackbar.SetLineSize(1);
	m_trackbar.SetPageSize(1);
	m_button1.Create("Linear", WS_CHILD|WS_VISIBLE|BS_AUTORADIOBUTTON,    CRect(150,0,250,33), this, IDC_BUTTON1);
	m_button2.Create("Butterfly", WS_CHILD|WS_VISIBLE|BS_AUTORADIOBUTTON, CRect(250,0,350,33), this, IDC_BUTTON2);
	m_button3.Create("Loop", WS_CHILD|WS_VISIBLE|BS_AUTORADIOBUTTON,      CRect(350,0,450,33), this, IDC_BUTTON3);
	m_button4.Create("Square3", WS_CHILD|WS_VISIBLE|BS_AUTORADIOBUTTON,   CRect(450,0,550,33), this, IDC_BUTTON4);
	CheckDlgButton(IDC_BUTTON1, BST_CHECKED); 
	/*
	this->renWin->AddRenderer(this->ren);
	// setup the parent window
	this->renWin->SetParentId(this->m_hWnd);
	this->iren->SetRenderWindow(this->renWin);
	*/

	return 0;
}

void CvtkSq3SubdivisionView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	CRect rect;
	if (!first)
	{this->GetClientRect(&rect);
	this->renWin->SetSize(rect.right-rect.left,rect.bottom-rect.top);
	}
}

BOOL CvtkSq3SubdivisionView::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: Add your message handler code here and/or call default
	
	//return CView::OnEraseBkgnd(pDC);
	return TRUE;
}

LRESULT CvtkSq3SubdivisionView::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	switch (message)
	{
		//case WM_PAINT: 
		case WM_LBUTTONDOWN: 
		case WM_LBUTTONUP: 
		case WM_MBUTTONDOWN: 
		case WM_MBUTTONUP: 
		case WM_RBUTTONDOWN: 
		case WM_RBUTTONUP: 
		case WM_MOUSEMOVE:
		case WM_CHAR:
		case WM_TIMER:
		if (!first)
		{if (this->iren->GetInitialized())
		{
			return vtkHandleMessage2(this->m_hWnd, message, wParam, lParam, this->iren);
		}}
		break;
	}

	
	return CView::WindowProc(message, wParam, lParam);
}

void CvtkSq3SubdivisionView::Pipeline ( void )
{
}
// CvtkSq3SubdivisionView Meldungshandler

void CvtkSq3SubdivisionView::OnClick ()
{
	if (m_button1.GetState() != 0) 
	{
		linearFilter->SetNumberOfSubdivisions(m_trackbar.GetPos());
		linearFilter->Update();
		ac = ren->GetActors();
		ac->InitTraversal();
		vtkActor *dsActor2=ac->GetNextActor();
		

		ac = importer->GetRenderer()->GetActors();
		ac->InitTraversal();
		vtkActor *dsActor=ac->GetNextActor();

		while (dsActor!=NULL) {
	    vtkPolyData *polyData = (vtkPolyData*)(dsActor->GetMapper()->GetInputAsDataSet());

	    vtkPolyDataMapper *mapper = vtkPolyDataMapper::New();
	    mapper->SetInput(linearFilter->GetOutput());
	    vtkActor *actor = vtkActor::New();

	    dsActor2->SetMapper(mapper);
	    dsActor2->SetProperty(dsActor->GetProperty()); 
	    
		dsActor=ac->GetNextActor();
		}

		Invalidate();
	}

	if (m_button2.GetState() != 0) 
	{
		butterflyFilter->SetNumberOfSubdivisions(m_trackbar.GetPos());
		butterflyFilter->Update();
		ac = ren->GetActors();
		ac->InitTraversal();
		vtkActor *dsActor2=ac->GetNextActor();
		

		ac = importer->GetRenderer()->GetActors();
		ac->InitTraversal();
		vtkActor *dsActor=ac->GetNextActor();

		while (dsActor!=NULL) {
	    vtkPolyData *polyData = (vtkPolyData*)(dsActor->GetMapper()->GetInputAsDataSet());

	    vtkPolyDataMapper *mapper = vtkPolyDataMapper::New();
	    mapper->SetInput(butterflyFilter->GetOutput());
	    vtkActor *actor = vtkActor::New();

	    dsActor2->SetMapper(mapper);
	    dsActor2->SetProperty(dsActor->GetProperty()); 
	    
		dsActor=ac->GetNextActor();
		}

		Invalidate();
	}

	if (m_button3.GetState() != 0) 
	{
		loopFilter->SetNumberOfSubdivisions(m_trackbar.GetPos());
		loopFilter->Update();
		ac = ren->GetActors();
		ac->InitTraversal();
		vtkActor *dsActor2=ac->GetNextActor();
		

		ac = importer->GetRenderer()->GetActors();
		ac->InitTraversal();
		vtkActor *dsActor=ac->GetNextActor();

		while (dsActor!=NULL) {
	    vtkPolyData *polyData = (vtkPolyData*)(dsActor->GetMapper()->GetInputAsDataSet());

	    vtkPolyDataMapper *mapper = vtkPolyDataMapper::New();
	    mapper->SetInput(loopFilter->GetOutput());
	    vtkActor *actor = vtkActor::New();

	    dsActor2->SetMapper(mapper);
	    dsActor2->SetProperty(dsActor->GetProperty()); 
	    
		dsActor=ac->GetNextActor();
		}

		Invalidate();
	}

	if (m_button4.GetState() != 0) 
	{
		loopFilter->SetNumberOfSubdivisions(m_trackbar.GetPos());
		loopFilter->Update();
		ac = ren->GetActors();
		ac->InitTraversal();
		vtkActor *dsActor2=ac->GetNextActor();
		

		ac = importer->GetRenderer()->GetActors();
		ac->InitTraversal();
		vtkActor *dsActor=ac->GetNextActor();

		while (dsActor!=NULL) {
	    vtkPolyData *polyData = (vtkPolyData*)(dsActor->GetMapper()->GetInputAsDataSet());

	    vtkPolyDataMapper *mapper = vtkPolyDataMapper::New();
	    mapper->SetInput(sq3Filter->GetOutput());
	    vtkActor *actor = vtkActor::New();

	    dsActor2->SetMapper(mapper);
	    dsActor2->SetProperty(dsActor->GetProperty()); 
	    
		dsActor=ac->GetNextActor();
		}

		Invalidate();
	}

}

void CvtkSq3SubdivisionView::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	// TODO: Fgen Sie hier Ihren Meldungsbehandlungscode ein, und/oder benutzen Sie den Standard.

   	int currentNumber = loopFilter->GetNumberOfSubdivisions();
	
	//if (currentNumber != m_trackbar.GetPos())
	{
	if (m_button1.GetState() != 0) 
	{
		linearFilter->SetNumberOfSubdivisions(m_trackbar.GetPos());
		linearFilter->Update();
		ac = ren->GetActors();
		ac->InitTraversal();
		vtkActor *dsActor2=ac->GetNextActor();
		

		ac = importer->GetRenderer()->GetActors();
		ac->InitTraversal();
		vtkActor *dsActor=ac->GetNextActor();

		while (dsActor!=NULL) {
	    vtkPolyData *polyData = (vtkPolyData*)(dsActor->GetMapper()->GetInputAsDataSet());

	    vtkPolyDataMapper *mapper = vtkPolyDataMapper::New();
	    mapper->SetInput(linearFilter->GetOutput());
	    vtkActor *actor = vtkActor::New();

	    dsActor2->SetMapper(mapper);
	    dsActor2->SetProperty(dsActor->GetProperty()); 
	    
		dsActor=ac->GetNextActor();
		}

		Invalidate();
	}

	if (m_button2.GetState() != 0) 
	{
		butterflyFilter->SetNumberOfSubdivisions(m_trackbar.GetPos());
		butterflyFilter->Update();
		ac = ren->GetActors();
		ac->InitTraversal();
		vtkActor *dsActor2=ac->GetNextActor();
		

		ac = importer->GetRenderer()->GetActors();
		ac->InitTraversal();
		vtkActor *dsActor=ac->GetNextActor();

		while (dsActor!=NULL) {
	    vtkPolyData *polyData = (vtkPolyData*)(dsActor->GetMapper()->GetInputAsDataSet());

	    vtkPolyDataMapper *mapper = vtkPolyDataMapper::New();
	    mapper->SetInput(butterflyFilter->GetOutput());
	    vtkActor *actor = vtkActor::New();

	    dsActor2->SetMapper(mapper);
	    dsActor2->SetProperty(dsActor->GetProperty()); 
	    
		dsActor=ac->GetNextActor();
		}

		Invalidate();
	}

	if (m_button3.GetState() != 0) 
	{
		loopFilter->SetNumberOfSubdivisions(m_trackbar.GetPos());
		loopFilter->Update();
		ac = ren->GetActors();
		ac->InitTraversal();
		vtkActor *dsActor2=ac->GetNextActor();
		

		ac = importer->GetRenderer()->GetActors();
		ac->InitTraversal();
		vtkActor *dsActor=ac->GetNextActor();

		while (dsActor!=NULL) {
	    vtkPolyData *polyData = (vtkPolyData*)(dsActor->GetMapper()->GetInputAsDataSet());

	    vtkPolyDataMapper *mapper = vtkPolyDataMapper::New();
	    mapper->SetInput(loopFilter->GetOutput());
	    vtkActor *actor = vtkActor::New();

	    dsActor2->SetMapper(mapper);
	    dsActor2->SetProperty(dsActor->GetProperty()); 
	    
		dsActor=ac->GetNextActor();
		}

		Invalidate();
	}

	if (m_button4.GetState() != 0) 
	{
		sq3Filter->SetNumberOfSubdivisions(m_trackbar.GetPos());
		sq3Filter->Update();
		ac = ren->GetActors();
		ac->InitTraversal();
		vtkActor *dsActor2=ac->GetNextActor();
		

		ac = importer->GetRenderer()->GetActors();
		ac->InitTraversal();
		vtkActor *dsActor=ac->GetNextActor();

		while (dsActor!=NULL) {
	    vtkPolyData *polyData = (vtkPolyData*)(dsActor->GetMapper()->GetInputAsDataSet());

	    vtkPolyDataMapper *mapper = vtkPolyDataMapper::New();
		mapper->SetInput(sq3Filter->GetOutput());
	    vtkActor *actor = vtkActor::New();

	    dsActor2->SetMapper(mapper);
	    dsActor2->SetProperty(dsActor->GetProperty()); 
	    
		dsActor=ac->GetNextActor();
		}

		Invalidate();
	}
	}

	CView::OnHScroll(nSBCode, nPos, pScrollBar);
}
