// vtkSq3SubdivisionView.h : Schnittstelle der Klasse CvtkSq3SubdivisionView
//


#pragma once

#include <vtkRenderer.h>
#include <vtkWin32OpenGLRenderWindow.h>
#include <vtkWin32RenderWindowInteractor.h>

#include <vtkSphereSource.h>
#include <vtkConeSource.h>
#include <vtkGlyph3D.h>
#include <vtkElevationFilter.h>
#include <vtkPolyDataMapper.h>
#include <vtkActor.h>
#include <vtkCubeAxesActor2D.h>
#include "vtkLoopSubdivisionFilter.h"
#include "vtkLinearSubdivisionFilter.h"
#include "vtkButterflySubdivisionFilter.h"
#include "VTK3DSOurImporter.h"
#include "vtkSQ3SubdivisionFilter.h"

class CvtkSq3SubdivisionView : public CView
{
protected: // Nur aus Serialisierung erstellen
	CvtkSq3SubdivisionView();
	DECLARE_DYNCREATE(CvtkSq3SubdivisionView)

// Attribute
public:
	CvtkSq3SubdivisionDoc* GetDocument() const;
// Operationen
public:

// berschreibungen
	public:
	virtual void OnDraw(CDC* pDC);  // berladen, um diese Ansicht darzustellen
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);

private:
	void Pipeline ( void );
	vtkWin32OpenGLRenderWindow *renWin;
	vtkRenderer *ren;
	vtkWin32RenderWindowInteractor *iren;
	vtkSphereSource *sphere;
	vtkPolyDataMapper *sphereMapper;
	vtkElevationFilter *sphereElevation;
	vtkActor *sphereActor;
	vtkConeSource *cone;
	vtkGlyph3D *glyph;
	vtkPolyDataMapper *spikeMapper;
	vtkActor *spikeActor;
	vtkCubeAxesActor2D *sphereAxis;
	vtkActorCollection *ac;
	vtkLoopSubdivisionFilter *loopFilter;
	vtkLinearSubdivisionFilter *linearFilter;
	vtkButterflySubdivisionFilter *butterflyFilter;
	vtkSQ3SubdivisionFilter *sq3Filter;

	VTK3DSOurImporter *importer;
	// Implementierung
public:
	CSliderCtrl m_trackbar;
	CButton m_button1, m_button2, m_button3, m_button4;
	virtual ~CvtkSq3SubdivisionView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generierte Funktionen fr die Meldungstabellen
protected:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnClick();
	DECLARE_MESSAGE_MAP()
public:
//	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
//	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
};

#ifndef _DEBUG  // Debugversion in vtkSq3SubdivisionView.cpp
inline CvtkSq3SubdivisionDoc* CvtkSq3SubdivisionView::GetDocument() const
   { return reinterpret_cast<CvtkSq3SubdivisionDoc*>(m_pDocument); }
#endif

